lorom		;Super Metroid (JU) Unheadered
			;Created by Flamestar666 on 4/22/10
			;http://Metroidconstruction.com
;_____INFORMATION_____
;This is an ASM file for 2 BTS blocks that allow you to reverse gravity while in ball mode
;It only activates out of a bombjump, and will not hold you in the air if you are not in a ball
;This patch uses Fool X-ray 03 to set normal gravity, and 04 to reverse it.
;While in reverse gravity, you bombjump down instead of up.

;Ideally, the BTS wants to be where ever the peak of the bombjump is. So unless you've modded something, you will need to put the blocks 3 tiles above the ground.
;putting too many blocks in a close together causes some instability.

;_____END OF INFO_____


;_Reverse Gavity variable. don't f#&k with this.
org $909132		;Hijack point for the check on what samus's air state is (ground, falling, in air, etc)
	JSR $F640	;points to free space in bank $90
	NOP			;needed to remove some code that was repointed (do not remove)
	NOP			;needed to remove some code that was repointed (do not remove)
	NOP			;needed to remove some code that was repointed (do not remove)
	
org $90F640		;Previously free space
	LDA $7EFD18	;unused ram address (used to store BTS values) If you change address, you need to change line 41 to reflect this one.
	CMP #$0001	;Compares this value to #$0001. If true, sets up reverse gravity
	BEQ AIR		
	

	LDA $0B36	;This is the operation repointed from $909132
	CMP #$0002	;If this compare is 0002, it continues with the normal routine of normal gravity
	RTS
	
AIR:	
	SEP #$20	;This operation make it check for 8bit values instead of 16 bit ones
	LDA $0A1F	;checks to make sure
	CMP #$06	;that samus is in a fall pose
	BNE UP		;if she is, she'll fall back down. This prevents you from falling infinitly into the air.
	REP #$20	;resets the operation make it check for 16bit values instead of 8 bit ones
	
	LDA #$0000	;clears the reverse btye -NOTE- I know I can STZ here, but I need to clear A anyways or else it won't work.
	STA $7EFD18	;stores the last LDA into this. If you change address, you need to change line 24 to reflect this one.
	STA $7EFD1C	;and into this. There were unused RAM addresses.
	RTS
UP:
	REP #$20
	LDA $0B36	;This is the same operation repointed from $909132
	CMP #$0001	;except if it is 0001, it'll make samus fall up.

	

	RTS
	
;(you can change this BTS to another BTS if you choose by adding 2 bytes to this address. $9498B2=03, $9498B4=04, $9498B6=05m etc.) !!!change them if your BTS blocks over lap.!!!
org $9498B2 	;Hijack point of Air-Fool X-Ray with a BTS 03 

DW $B300		;Writes 00 B3 into $9498B2

org $94B300 	;free space

	LDA #$0000	;should probably use STZ, but it doesn't seem to work correctly. but meh.
	STA $7EFD18	;clears the byte set to make samus fall up
	STA $7EFD1C	;I use this to make sure the sound byte doesn't repeat.
	RTS

org $9498B4 	;Hijack point of Air-Fool X-Ray with a BTS 04

DW $B400		;this points to free space in the ROM

org $94B400 	;Free space

			;Checks if you are in a ball form
	SEP #$20
	LDA $0A1F	;Samus's pose
	CMP #$11	;Makes sure samus is in Springball
	BEQ REV
	
	CMP #$13	;Makes sure samus is in Springball
	BEQ REV
	;you can remove (add a semicolon before the code) this until my next comment to make this only work in springball form
	CMP #$04	
	BEQ REV
	
	CMP #$08
	BEQ REV	;If you want to remove morphball reverse gravity, don't delete the REP code.
	REP #$20
			;end of check
			
	LDA #$0000	;same as above
	STA $7EFD18
	STA $7EFD1C
	RTS

REV:
	REP #$20
	LDA $0A56	;Checks to make sure you are actually bombjumping, if you are not, it will not activate
	BEQ QUIT	;Is this value is equal to 0, it branches to the branch QUIT. If you wish, you can change it to BNE to make it so it goes up if you're not bombjumping. or remove it to disable the bombjump check. remove the LDA if you wish as well
	
	LDA #$0001	;sets the byte to set up samus falling upwards
	STA $7EFD18	;normally unused ram
	LDA $7EFD1C	;Unused RAM, used to make sure that the sound only plays once
	BNE NOSOUND
	LDA $0AF6			;Load samus's X position
	STA $12	
	LDA $0AFA			;Load samus's Y position
	STA $14
	LDA #$0001			;which graphic to use (0001, 0005, 0006 are cool too. try more)
	STA $16				;
	STZ $18
	JSL $B4BC26			;Run graphic spawning routine
	LDA #$0038	;LDA for sound (refer to http://jathys.zophar.net/supermetroid/kejardon/RandomRoutines.txt for more sounds
	JSL $8090A3	;routine for sound (currently using sound library 2.)
NOSOUND:
	STA $7EFD1C	;stores it
	
QUIT:
	RTS